Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 15764)
@@ -22,4 +22,5 @@
    USE obs_read_surf            ! Reading and allocation of surface obs
    USE obs_readmdt              ! Reading and allocation of MDT for SLA.
+   USE obs_readsnowdepth        ! Get model snow depth for conversion of freeboard to ice thickness
    USE obs_prep                 ! Preparation of obs. (grid search etc).
    USE obs_oper                 ! Observation operators
@@ -33,4 +34,5 @@
    USE mpp_map                  ! MPP mapping
    USE lib_mpp                  ! For ctl_warn/stop
+   USE tradmp                   ! For climatological temperature & salinity
 
    IMPLICIT NONE
@@ -44,32 +46,49 @@
 
    !! * Module variables
-   LOGICAL, PUBLIC :: &
-      &       lk_diaobs = .TRUE.   !: Include this for backwards compatibility at NEMO 3.6.
-   LOGICAL :: ln_diaobs            !: Logical switch for the obs operator
-   LOGICAL :: ln_sstnight          !: Logical switch for night mean SST obs
-   LOGICAL :: ln_default_fp_indegs !: T=> Default obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sla_fp_indegs     !: T=>     SLA obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sst_fp_indegs     !: T=>     SST obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sss_fp_indegs     !: T=>     SSS obs footprint size specified in degrees, F=> in metres
-   LOGICAL :: ln_sic_fp_indegs     !: T=> sea-ice obs footprint size specified in degrees, F=> in metres
-
-   REAL(wp) :: rn_default_avglamscl !: Default E/W diameter of observation footprint
-   REAL(wp) :: rn_default_avgphiscl !: Default N/S diameter of observation footprint
-   REAL(wp) :: rn_sla_avglamscl     !: E/W diameter of SLA observation footprint
-   REAL(wp) :: rn_sla_avgphiscl     !: N/S diameter of SLA observation footprint
-   REAL(wp) :: rn_sst_avglamscl     !: E/W diameter of SST observation footprint
-   REAL(wp) :: rn_sst_avgphiscl     !: N/S diameter of SST observation footprint
-   REAL(wp) :: rn_sss_avglamscl     !: E/W diameter of SSS observation footprint
-   REAL(wp) :: rn_sss_avgphiscl     !: N/S diameter of SSS observation footprint
-   REAL(wp) :: rn_sic_avglamscl     !: E/W diameter of sea-ice observation footprint
-   REAL(wp) :: rn_sic_avgphiscl     !: N/S diameter of sea-ice observation footprint
-
-   INTEGER :: nn_1dint         !: Vertical interpolation method
-   INTEGER :: nn_2dint_default !: Default horizontal interpolation method
-   INTEGER :: nn_2dint_sla     !: SLA horizontal interpolation method (-1 = default)
-   INTEGER :: nn_2dint_sst     !: SST horizontal interpolation method (-1 = default)
-   INTEGER :: nn_2dint_sss     !: SSS horizontal interpolation method (-1 = default)
-   INTEGER :: nn_2dint_sic     !: Seaice horizontal interpolation method (-1 = default)
- 
+   LOGICAL, PUBLIC :: & 
+      &       lk_diaobs = .TRUE.   !: Include this for backwards compatibility at NEMO 3.6. 
+   LOGICAL :: ln_diaobs            !: Logical switch for the obs operator 
+   LOGICAL :: ln_sstnight          !: Logical switch for night mean SST obs 
+   LOGICAL :: ln_default_fp_indegs !: T=> Default obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_sla_fp_indegs     !: T=> SLA obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_sst_fp_indegs     !: T=> SST obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_sss_fp_indegs     !: T=> SSS obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_ssv_fp_indegs     !: T=> SSV obs footprint size specified in degrees, F=> in metres    
+   LOGICAL :: ln_sic_fp_indegs     !: T=> SIC obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_sit_fp_indegs     !: T=> SIT obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_fbd_fp_indegs     !: T=> SIT obs footprint size specified in degrees, F=> in metres 
+   LOGICAL :: ln_output_clim       !: Logical switch for interpolating and writing T/S climatology 
+   LOGICAL :: ln_time_mean_sla_bkg !: Logical switch for applying time mean of SLA background to remove tidal signal 
+
+   REAL(wp) :: rn_default_avglamscl !: Default E/W diameter of observation footprint 
+   REAL(wp) :: rn_default_avgphiscl !: Default N/S diameter of observation footprint 
+   REAL(wp) :: rn_sla_avglamscl     !: E/W diameter of SLA observation footprint 
+   REAL(wp) :: rn_sla_avgphiscl     !: N/S diameter of SLA observation footprint 
+   REAL(wp) :: rn_sst_avglamscl     !: E/W diameter of SST observation footprint 
+   REAL(wp) :: rn_sst_avgphiscl     !: N/S diameter of SST observation footprint 
+   REAL(wp) :: rn_sss_avglamscl     !: E/W diameter of SSS observation footprint 
+   REAL(wp) :: rn_sss_avgphiscl     !: N/S diameter of SSS observation footprint 
+   REAL(wp) :: rn_ssv_avglamscl     !: E/W diameter of SSV observation footprint 
+   REAL(wp) :: rn_ssv_avgphiscl     !: N/S diameter of SSV observation footprint 
+   REAL(wp) :: rn_sic_avglamscl     !: E/W diameter of SIC observation footprint 
+   REAL(wp) :: rn_sic_avgphiscl     !: N/S diameter of SIC observation footprint 
+   REAL(wp) :: rn_sit_avglamscl     !: E/W diameter of SIT observation footprint 
+   REAL(wp) :: rn_sit_avgphiscl     !: N/S diameter of SIT observation footprint 
+   REAL(wp) :: rn_fbd_avglamscl     !: E/W diameter of FBD observation footprint 
+   REAL(wp) :: rn_fbd_avgphiscl     !: N/S diameter of FBD observation footprint 
+   REAL(wp), PUBLIC :: & 
+      &        MeanPeriodHours = 24. + (5./6.) !: Meaning period for surface data. 
+
+
+   INTEGER :: nn_1dint         !: Vertical interpolation method 
+   INTEGER :: nn_2dint_default !: Default horizontal interpolation method 
+   INTEGER :: nn_2dint_sla     !: SLA horizontal interpolation method (-1 = default) 
+   INTEGER :: nn_2dint_sst     !: SST horizontal interpolation method (-1 = default) 
+   INTEGER :: nn_2dint_sss     !: SSS horizontal interpolation method (-1 = default) 
+   INTEGER :: nn_2dint_ssv     !: SSV horizontal interpolation method (-1 = default)    
+   INTEGER :: nn_2dint_sic     !: SIC horizontal interpolation method (-1 = default) 
+   INTEGER :: nn_2dint_sit     !: SIT horizontal interpolation method (-1 = default) 
+   INTEGER :: nn_2dint_fbd     !: FBD horizontal interpolation method (-1 = default)
+
    INTEGER, DIMENSION(imaxavtypes) :: &
       & nn_profdavtypes      !: Profile data types representing a daily average
@@ -130,157 +149,186 @@
       !!        !  15-02  (M. Martin) Simplification of namelist and code
       !!----------------------------------------------------------------------
+#if defined key_cice 
+USE sbc_oce, ONLY : &        ! CICE variables 
+   & thick_s                 ! snow depth for freeboard conversion  
+#endif
 
       IMPLICIT NONE
 
       !! * Local declarations
-      INTEGER, PARAMETER :: &
-         & jpmaxnfiles = 1000    ! Maximum number of files for each obs type
-      INTEGER, DIMENSION(:), ALLOCATABLE :: &
-         & ifilesprof, &         ! Number of profile files
-         & ifilessurf            ! Number of surface files
-      INTEGER :: ios             ! Local integer output status for namelist read
-      INTEGER :: jtype           ! Counter for obs types
-      INTEGER :: jvar            ! Counter for variables
-      INTEGER :: jfile           ! Counter for files
-      INTEGER :: jnumsstbias     ! Number of SST bias files to read and apply
-      INTEGER :: n2dint_type     ! Local version of nn_2dint*
-
-      CHARACTER(len=128), DIMENSION(jpmaxnfiles) :: &
-         & cn_profbfiles,      & ! T/S profile input filenames
-         & cn_sstfbfiles,      & ! Sea surface temperature input filenames
-         & cn_slafbfiles,      & ! Sea level anomaly input filenames
-         & cn_sicfbfiles,      & ! Seaice concentration input filenames
-         & cn_velfbfiles,      & ! Velocity profile input filenames
-         & cn_sssfbfiles,      & ! Sea surface salinity input filenames
-         & cn_slchltotfbfiles, & ! Surface total              log10(chlorophyll) input filenames
-         & cn_slchldiafbfiles, & ! Surface diatom             log10(chlorophyll) input filenames
-         & cn_slchlnonfbfiles, & ! Surface non-diatom         log10(chlorophyll) input filenames
-         & cn_slchldinfbfiles, & ! Surface dinoflagellate     log10(chlorophyll) input filenames
-         & cn_slchlmicfbfiles, & ! Surface microphytoplankton log10(chlorophyll) input filenames
-         & cn_slchlnanfbfiles, & ! Surface nanophytoplankton  log10(chlorophyll) input filenames
-         & cn_slchlpicfbfiles, & ! Surface picophytoplankton  log10(chlorophyll) input filenames
-         & cn_schltotfbfiles,  & ! Surface total              chlorophyll        input filenames
-         & cn_slphytotfbfiles, & ! Surface total      log10(phytoplankton carbon) input filenames
-         & cn_slphydiafbfiles, & ! Surface diatom     log10(phytoplankton carbon) input filenames
-         & cn_slphynonfbfiles, & ! Surface non-diatom log10(phytoplankton carbon) input filenames
-         & cn_sspmfbfiles,     & ! Surface suspended particulate matter input filenames
-         & cn_sfco2fbfiles,    & ! Surface fugacity         of carbon dioxide input filenames
-         & cn_spco2fbfiles,    & ! Surface partial pressure of carbon dioxide input filenames
-         & cn_plchltotfbfiles, & ! Profile total log10(chlorophyll) input filenames
-         & cn_pchltotfbfiles,  & ! Profile total chlorophyll input filenames
-         & cn_pno3fbfiles,     & ! Profile nitrate input filenames
-         & cn_psi4fbfiles,     & ! Profile silicate input filenames
-         & cn_ppo4fbfiles,     & ! Profile phosphate input filenames
-         & cn_pdicfbfiles,     & ! Profile dissolved inorganic carbon input filenames
-         & cn_palkfbfiles,     & ! Profile alkalinity input filenames
-         & cn_pphfbfiles,      & ! Profile pH input filenames
-         & cn_po2fbfiles,      & ! Profile dissolved oxygen input filenames
-         & cn_sstbiasfiles       ! SST bias input filenames
-
-      CHARACTER(LEN=128) :: &
-         & cn_altbiasfile        ! Altimeter bias input filename
-
-
-      LOGICAL :: ln_t3d          ! Logical switch for temperature profiles
-      LOGICAL :: ln_s3d          ! Logical switch for salinity profiles
-      LOGICAL :: ln_sla          ! Logical switch for sea level anomalies 
-      LOGICAL :: ln_sst          ! Logical switch for sea surface temperature
-      LOGICAL :: ln_sic          ! Logical switch for sea ice concentration
-      LOGICAL :: ln_sss          ! Logical switch for sea surface salinity obs
-      LOGICAL :: ln_vel3d        ! Logical switch for velocity (u,v) obs
-      LOGICAL :: ln_slchltot     ! Logical switch for surface total              log10(chlorophyll) obs
-      LOGICAL :: ln_slchldia     ! Logical switch for surface diatom             log10(chlorophyll) obs
-      LOGICAL :: ln_slchlnon     ! Logical switch for surface non-diatom         log10(chlorophyll) obs
-      LOGICAL :: ln_slchldin     ! Logical switch for surface dinoflagellate     log10(chlorophyll) obs
-      LOGICAL :: ln_slchlmic     ! Logical switch for surface microphytoplankton log10(chlorophyll) obs
-      LOGICAL :: ln_slchlnan     ! Logical switch for surface nanophytoplankton  log10(chlorophyll) obs
-      LOGICAL :: ln_slchlpic     ! Logical switch for surface picophytoplankton  log10(chlorophyll) obs
-      LOGICAL :: ln_schltot      ! Logical switch for surface total              chlorophyll        obs
-      LOGICAL :: ln_slphytot     ! Logical switch for surface total      log10(phytoplankton carbon) obs
-      LOGICAL :: ln_slphydia     ! Logical switch for surface diatom     log10(phytoplankton carbon) obs
-      LOGICAL :: ln_slphynon     ! Logical switch for surface non-diatom log10(phytoplankton carbon) obs
-      LOGICAL :: ln_sspm         ! Logical switch for surface suspended particulate matter obs
-      LOGICAL :: ln_sfco2        ! Logical switch for surface fugacity         of carbon dioxide obs
-      LOGICAL :: ln_spco2        ! Logical switch for surface partial pressure of carbon dioxide obs
-      LOGICAL :: ln_plchltot     ! Logical switch for profile total log10(chlorophyll) obs
-      LOGICAL :: ln_pchltot      ! Logical switch for profile total chlorophyll obs
-      LOGICAL :: ln_pno3         ! Logical switch for profile nitrate obs
-      LOGICAL :: ln_psi4         ! Logical switch for profile silicate obs
-      LOGICAL :: ln_ppo4         ! Logical switch for profile phosphate obs
-      LOGICAL :: ln_pdic         ! Logical switch for profile dissolved inorganic carbon obs
-      LOGICAL :: ln_palk         ! Logical switch for profile alkalinity obs
-      LOGICAL :: ln_pph          ! Logical switch for profile pH obs
-      LOGICAL :: ln_po2          ! Logical switch for profile dissolved oxygen obs
-      LOGICAL :: ln_nea          ! Logical switch to remove obs near land
-      LOGICAL :: ln_altbias      ! Logical switch for altimeter bias
-      LOGICAL :: ln_sstbias      ! Logical switch for bias correction of SST
-      LOGICAL :: ln_ignmis       ! Logical switch for ignoring missing files
-      LOGICAL :: ln_s_at_t       ! Logical switch to compute model S at T obs
-      LOGICAL :: ln_bound_reject ! Logical switch for rejecting obs near the boundary
-
-      REAL(dp) :: rn_dobsini     ! Obs window start date YYYYMMDD.HHMMSS
-      REAL(dp) :: rn_dobsend     ! Obs window end date   YYYYMMDD.HHMMSS
-
-      REAL(wp) :: ztype_avglamscl ! Local version of rn_*_avglamscl
-      REAL(wp) :: ztype_avgphiscl ! Local version of rn_*_avgphiscl
-
-      CHARACTER(len=128), DIMENSION(:,:), ALLOCATABLE :: &
-         & clproffiles, &        ! Profile filenames
-         & clsurffiles           ! Surface filenames
-
-      LOGICAL, DIMENSION(:), ALLOCATABLE :: llvar   ! Logical for profile variable read
-      LOGICAL :: ltype_fp_indegs ! Local version of ln_*_fp_indegs
-      LOGICAL :: ltype_night     ! Local version of ln_sstnight (false for other variables)
-
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: &
-         & zglam                 ! Model longitudes for profile variables
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: &
-         & zgphi                 ! Model latitudes for profile variables
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: &
-         & zmask                 ! Model land/sea mask associated with variables
-
-
-      NAMELIST/namobs/ln_diaobs, ln_t3d, ln_s3d, ln_sla,              &
-         &            ln_sst, ln_sic, ln_sss, ln_vel3d,               &
-         &            ln_slchltot, ln_slchldia, ln_slchlnon,          &
-         &            ln_slchldin, ln_slchlmic, ln_slchlnan,          &
-         &            ln_slchlpic, ln_schltot,                        &
-         &            ln_slphytot, ln_slphydia, ln_slphynon,          &
-         &            ln_sspm,     ln_sfco2,    ln_spco2,             &
-         &            ln_plchltot, ln_pchltot,  ln_pno3,              &
-         &            ln_psi4,     ln_ppo4,     ln_pdic,              &
-         &            ln_palk,     ln_pph,      ln_po2,               &
-         &            ln_altbias, ln_sstbias, ln_nea,                 &
-         &            ln_grid_global, ln_grid_search_lookup,          &
-         &            ln_ignmis, ln_s_at_t, ln_bound_reject,          &
-         &            ln_sstnight, ln_default_fp_indegs,              &
-         &            ln_sla_fp_indegs, ln_sst_fp_indegs,             &
-         &            ln_sss_fp_indegs, ln_sic_fp_indegs,             &
-         &            cn_profbfiles, cn_slafbfiles,                   &
-         &            cn_sstfbfiles, cn_sicfbfiles,                   &
-         &            cn_velfbfiles, cn_sssfbfiles,                   &
-         &            cn_slchltotfbfiles, cn_slchldiafbfiles,         &
-         &            cn_slchlnonfbfiles, cn_slchldinfbfiles,         &
-         &            cn_slchlmicfbfiles, cn_slchlnanfbfiles,         &
-         &            cn_slchlpicfbfiles, cn_schltotfbfiles,          &
-         &            cn_slphytotfbfiles, cn_slphydiafbfiles,         &
-         &            cn_slphynonfbfiles, cn_sspmfbfiles,             &
-         &            cn_sfco2fbfiles, cn_spco2fbfiles,               &
-         &            cn_plchltotfbfiles, cn_pchltotfbfiles,          &
-         &            cn_pno3fbfiles, cn_psi4fbfiles, cn_ppo4fbfiles, &
-         &            cn_pdicfbfiles, cn_palkfbfiles, cn_pphfbfiles,  &
-         &            cn_po2fbfiles,                                  &
-         &            cn_sstbiasfiles, cn_altbiasfile,                &
-         &            cn_gridsearchfile, rn_gridsearchres,            &
-         &            rn_dobsini, rn_dobsend,                         &
-         &            rn_default_avglamscl, rn_default_avgphiscl,     &
-         &            rn_sla_avglamscl, rn_sla_avgphiscl,             &
-         &            rn_sst_avglamscl, rn_sst_avgphiscl,             &
-         &            rn_sss_avglamscl, rn_sss_avgphiscl,             &
-         &            rn_sic_avglamscl, rn_sic_avgphiscl,             &
-         &            nn_1dint, nn_2dint_default,                     &
-         &            nn_2dint_sla, nn_2dint_sst,                     &
-         &            nn_2dint_sss, nn_2dint_sic,                     &
-         &            nn_msshc, rn_mdtcorr, rn_mdtcutoff,             &
+      INTEGER, PARAMETER :: & 
+         & jpmaxnfiles = 1000    ! Maximum number of files for each obs type 
+      INTEGER, DIMENSION(:), ALLOCATABLE :: & 
+         & ifilesprof, &         ! Number of profile files 
+         & ifilessurf            ! Number of surface files 
+      INTEGER :: ios             ! Local integer output status for namelist read 
+      INTEGER :: jtype           ! Counter for obs types 
+      INTEGER :: jvar            ! Counter for variables 
+      INTEGER :: jfile           ! Counter for files 
+      INTEGER :: jnumsstbias     ! Number of SST bias files to read and apply 
+      INTEGER :: n2dint_type     ! Local version of nn_2dint* 
+
+      CHARACTER(len=128), DIMENSION(jpmaxnfiles) :: & 
+         & cn_profbfiles,      & ! T/S profile input filenames 
+         & cn_sstfbfiles,      & ! Sea surface temperature input filenames 
+         & cn_slafbfiles,      & ! Sea level anomaly input filenames 
+         & cn_sicfbfiles,      & ! Seaice concentration input filenames 
+         & cn_sitfbfiles,      & ! Seaice thickness input filenames 
+         & cn_fbdfbfiles,      & ! Seaice freeboard input filenames 
+         & cn_velfbfiles,      & ! Velocity profile input filenames 
+         & cn_sssfbfiles,      & ! Sea surface salinity input filenames 
+         & cn_ssvfbfiles,      & ! Sea surface velocity input filenames          
+         & cn_slchltotfbfiles, & ! Surface total log10(chlorophyll) input filenames 
+         & cn_slchldiafbfiles, & ! Surface diatom log10(chlorophyll) input filenames 
+         & cn_slchlnonfbfiles, & ! Surface non-diatom log10(chlorophyll) input filenames 
+         & cn_slchldinfbfiles, & ! Surface dinoflagellate log10(chlorophyll) input filenames 
+         & cn_slchlmicfbfiles, & ! Surface microphytoplankton log10(chlorophyll) input filenames 
+         & cn_slchlnanfbfiles, & ! Surface nanophytoplankton log10(chlorophyll) input filenames 
+         & cn_slchlpicfbfiles, & ! Surface picophytoplankton log10(chlorophyll) input filenames 
+         & cn_schltotfbfiles,  & ! Surface total chlorophyll        input filenames 
+         & cn_slphytotfbfiles, & ! Surface total log10(phytoplankton carbon) input filenames 
+         & cn_slphydiafbfiles, & ! Surface diatom log10(phytoplankton carbon) input filenames 
+         & cn_slphynonfbfiles, & ! Surface non-diatom log10(phytoplankton carbon) input filenames 
+         & cn_sspmfbfiles,     & ! Surface suspended particulate matter input filenames 
+         & cn_skd490fbfiles,   & ! Surface Kd490 input filenames 
+         & cn_sfco2fbfiles,    & ! Surface fugacity         of carbon dioxide input filenames 
+         & cn_spco2fbfiles,    & ! Surface partial pressure of carbon dioxide input filenames 
+         & cn_plchltotfbfiles, & ! Profile total log10(chlorophyll) input filenames 
+         & cn_pchltotfbfiles,  & ! Profile total chlorophyll input filenames 
+         & cn_pno3fbfiles,     & ! Profile nitrate input filenames 
+         & cn_psi4fbfiles,     & ! Profile silicate input filenames 
+         & cn_ppo4fbfiles,     & ! Profile phosphate input filenames 
+         & cn_pdicfbfiles,     & ! Profile dissolved inorganic carbon input filenames 
+         & cn_palkfbfiles,     & ! Profile alkalinity input filenames 
+         & cn_pphfbfiles,      & ! Profile pH input filenames 
+         & cn_po2fbfiles,      & ! Profile dissolved oxygen input filenames 
+         & cn_sstbiasfiles       ! SST bias input filenames 
+
+      CHARACTER(LEN=128) :: & 
+         & cn_altbiasfile        ! Altimeter bias input filename 
+
+
+      LOGICAL :: ln_seaicetypes = .FALSE.          ! Logical switch indicating data type is sea ice 
+      LOGICAL :: ln_t3d          ! Logical switch for temperature profiles 
+      LOGICAL :: ln_s3d          ! Logical switch for salinity profiles 
+      LOGICAL :: ln_sla          ! Logical switch for sea level anomalies  
+      LOGICAL :: ln_sst          ! Logical switch for sea surface temperature 
+      LOGICAL :: ln_sic          ! Logical switch for sea ice concentration 
+      LOGICAL :: ln_sit          ! Logical switch for sea ice thickness 
+      LOGICAL :: ln_fbd          ! Logical switch for sea ice freeboard 
+      LOGICAL :: ln_sss          ! Logical switch for sea surface salinity obs 
+      LOGICAL :: ln_ssv          ! Logical switch for sea surface velocity obs       
+      LOGICAL :: ln_vel3d        ! Logical switch for velocity (u,v) obs 
+      LOGICAL :: ln_slchltot     ! Logical switch for surface total              log10(chlorophyll) obs 
+      LOGICAL :: ln_slchldia     ! Logical switch for surface diatom             log10(chlorophyll) obs 
+      LOGICAL :: ln_slchlnon     ! Logical switch for surface non-diatom         log10(chlorophyll) obs 
+      LOGICAL :: ln_slchldin     ! Logical switch for surface dinoflagellate     log10(chlorophyll) obs 
+      LOGICAL :: ln_slchlmic     ! Logical switch for surface microphytoplankton log10(chlorophyll) obs 
+      LOGICAL :: ln_slchlnan     ! Logical switch for surface nanophytoplankton  log10(chlorophyll) obs 
+      LOGICAL :: ln_slchlpic     ! Logical switch for surface picophytoplankton  log10(chlorophyll) obs 
+      LOGICAL :: ln_schltot      ! Logical switch for surface total              chlorophyll        obs 
+      LOGICAL :: ln_slphytot     ! Logical switch for surface total      log10(phytoplankton carbon) obs 
+      LOGICAL :: ln_slphydia     ! Logical switch for surface diatom     log10(phytoplankton carbon) obs 
+      LOGICAL :: ln_slphynon     ! Logical switch for surface non-diatom log10(phytoplankton carbon) obs 
+      LOGICAL :: ln_sspm         ! Logical switch for surface suspended particulate matter obs 
+      LOGICAL :: ln_skd490       ! Logical switch for surface Kd490 
+      LOGICAL :: ln_sfco2        ! Logical switch for surface fugacity         of carbon dioxide obs 
+      LOGICAL :: ln_spco2        ! Logical switch for surface partial pressure of carbon dioxide obs 
+      LOGICAL :: ln_plchltot     ! Logical switch for profile total log10(chlorophyll) obs 
+      LOGICAL :: ln_pchltot      ! Logical switch for profile total chlorophyll obs 
+      LOGICAL :: ln_pno3         ! Logical switch for profile nitrate obs 
+      LOGICAL :: ln_psi4         ! Logical switch for profile silicate obs 
+      LOGICAL :: ln_ppo4         ! Logical switch for profile phosphate obs 
+      LOGICAL :: ln_pdic         ! Logical switch for profile dissolved inorganic carbon obs 
+      LOGICAL :: ln_palk         ! Logical switch for profile alkalinity obs 
+      LOGICAL :: ln_pph          ! Logical switch for profile pH obs 
+      LOGICAL :: ln_po2          ! Logical switch for profile dissolved oxygen obs 
+      LOGICAL :: ln_nea          ! Logical switch to remove obs near land 
+      LOGICAL :: ln_altbias      ! Logical switch for altimeter bias 
+      LOGICAL :: ln_sstbias      ! Logical switch for bias correction of SST 
+      LOGICAL :: ln_ignmis       ! Logical switch for ignoring missing files 
+      LOGICAL :: ln_s_at_t       ! Logical switch to compute model S at T obs 
+      LOGICAL :: ln_bound_reject ! Logical switch for rejecting obs near the boundary 
+
+      REAL(dp) :: rn_dobsini     ! Obs window start date YYYYMMDD.HHMMSS 
+      REAL(dp) :: rn_dobsend     ! Obs window end date YYYYMMDD.HHMMSS 
+
+      REAL(wp) :: ztype_avglamscl ! Local version of rn_*_avglamscl 
+      REAL(wp) :: ztype_avgphiscl ! Local version of rn_*_avgphiscl 
+
+      CHARACTER(len=128), DIMENSION(:,:), ALLOCATABLE :: & 
+         & clproffiles, &        ! Profile filenames 
+         & clsurffiles           ! Surface filenames 
+      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvars  ! Expected variable names 
+
+      LOGICAL, DIMENSION(:), ALLOCATABLE :: llvar   ! Logical for profile variable read 
+      LOGICAL :: ltype_fp_indegs ! Local version of ln_*_fp_indegs 
+      LOGICAL :: ltype_night     ! Local version of ln_sstnight (false for other variables) 
+      LOGICAL :: ltype_clim      ! Local version of ln_output_clim 
+
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & zglam                 ! Model longitudes for profile variables 
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & zgphi                 ! Model latitudes for profile variables 
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: & 
+         & zmask                 ! Model land/sea mask associated with variables 
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: & 
+         & zmask_surf            ! Surface model land/sea mask associated with variables 
+
+
+      NAMELIST/namobs/ln_diaobs, ln_t3d, ln_s3d, ln_sla,              & 
+         &            ln_sst, ln_sic, ln_sit, ln_fbd,                 & 
+         &            ln_sss, ln_ssv, ln_vel3d,                       & 
+         &            ln_slchltot, ln_slchldia, ln_slchlnon,          & 
+         &            ln_slchldin, ln_slchlmic, ln_slchlnan,          & 
+         &            ln_slchlpic, ln_schltot,                        & 
+         &            ln_slphytot, ln_slphydia, ln_slphynon,          & 
+         &            ln_sspm,     ln_sfco2,    ln_spco2,             & 
+         &            ln_skd490,                                      & 
+         &            ln_plchltot, ln_pchltot,  ln_pno3,              & 
+         &            ln_psi4,     ln_ppo4,     ln_pdic,              & 
+         &            ln_palk,     ln_pph,      ln_po2,               & 
+         &            ln_altbias, ln_sstbias, ln_nea,                 & 
+         &            ln_grid_global, ln_grid_search_lookup,          & 
+         &            ln_ignmis, ln_s_at_t, ln_bound_reject,          & 
+         &            ln_sstnight,  ln_output_clim,                   & 
+         &            ln_time_mean_sla_bkg, ln_default_fp_indegs,     & 
+         &            ln_sla_fp_indegs, ln_sst_fp_indegs,             & 
+         &            ln_sss_fp_indegs, ln_ssv_fp_indegs,             & 
+         &            ln_sic_fp_indegs, ln_sit_fp_indegs,             & 
+         &            ln_fbd_fp_indegs,                               & 
+         &            cn_profbfiles, cn_slafbfiles,                   & 
+         &            cn_sstfbfiles, cn_sicfbfiles,                   & 
+         &            cn_sitfbfiles, cn_fbdfbfiles,                   & 
+         &            cn_velfbfiles, cn_sssfbfiles, cn_ssvfbfiles,    & 
+         &            cn_slchltotfbfiles, cn_slchldiafbfiles,         & 
+         &            cn_slchlnonfbfiles, cn_slchldinfbfiles,         & 
+         &            cn_slchlmicfbfiles, cn_slchlnanfbfiles,         & 
+         &            cn_slchlpicfbfiles, cn_schltotfbfiles,          & 
+         &            cn_slphytotfbfiles, cn_slphydiafbfiles,         & 
+         &            cn_slphynonfbfiles, cn_sspmfbfiles,             & 
+         &            cn_skd490fbfiles,                               & 
+         &            cn_sfco2fbfiles, cn_spco2fbfiles,               & 
+         &            cn_plchltotfbfiles, cn_pchltotfbfiles,          & 
+         &            cn_pno3fbfiles, cn_psi4fbfiles, cn_ppo4fbfiles, & 
+         &            cn_pdicfbfiles, cn_palkfbfiles, cn_pphfbfiles,  & 
+         &            cn_po2fbfiles,                                  & 
+         &            cn_sstbiasfiles, cn_altbiasfile,                & 
+         &            cn_gridsearchfile, rn_gridsearchres,            & 
+         &            rn_dobsini, rn_dobsend,                         & 
+         &            rn_default_avglamscl, rn_default_avgphiscl,     & 
+         &            rn_sla_avglamscl, rn_sla_avgphiscl,             & 
+         &            rn_sst_avglamscl, rn_sst_avgphiscl,             & 
+         &            rn_sss_avglamscl, rn_sss_avgphiscl,             & 
+         &            rn_ssv_avglamscl, rn_ssv_avgphiscl,             &          
+         &            rn_sic_avglamscl, rn_sic_avgphiscl,             & 
+         &            rn_sit_avglamscl, rn_sit_avgphiscl,             & 
+         &            rn_fbd_avglamscl, rn_fbd_avgphiscl,             & 
+         &            nn_1dint, nn_2dint_default,                     & 
+         &            nn_2dint_sla, nn_2dint_sst,                     & 
+         &            nn_2dint_sss, nn_2dint_ssv,                     & 
+         &            nn_2dint_sic, nn_2dint_sit,                     & 
+         &            nn_2dint_fbd,                                   & 
+         &            nn_msshc, rn_mdtcorr, rn_mdtcutoff,             & 
          &            nn_profdavtypes
 
